#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
#  This Datapack was generated for private distribution only  #
# ----------------------------------------------------------- #
#                         DATAPACK INFO                       #
# ----------------------------------------------------------- #
#     Author: GenMode                                         #
#     Twitter: @DatapackGen                                   #
#     URL: https://github.com/GenMode/Minecraft/wiki          #
#                                                             #
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#


# Init
$execute if data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage{store_items:true} run function data_api:run/containers/player_gui/functions/copy_inventory_to_storage {path:"SelectedPage.Items", UUID:"$(UUID)"}
$execute if data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage{store_items:true} run function data_api:run/containers/player_gui/functions/page_macro {nbt:"count", function:"data_api:run/containers/player_gui/functions/clear_item"}
$execute if data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage run function data_api:run/containers/player_gui/functions/copy_selected_page_to_storage with storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage

# Modify Data
function data_api:run/containers/custom_gui/functions/clear_cursor
function data_api:run/commands/check_inventory/if_data {data:"components.\"minecraft:custom_data\".gui", function:"data_api:run/containers/player_gui/functions/clear_gui"}
function data_api:run/commands/check_inventory/if_data {data:"components.\"minecraft:custom_data\"{has_temporary_data:true}", function:"data_api:run/containers/player_gui/functions/remove_custom_data"}
function data_api:run/containers/player_gui/functions/page_macro_if_unless {if_nbt:"count", unless_nbt:"components.\"minecraft:custom_data\".gui", function:"data_api:run/containers/player_gui/functions/return_item_from_page"}
$function data_api:run/containers/player_gui/functions/copy_storage_to_inventory {path:"Inventory", UUID:"$(UUID)"}

# Close
$data remove storage data:store PlayerGUI[{UUID:$(UUID)}].Inventory
$data remove storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage
scoreboard players set @s gui.Page 0
