#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
#  This Datapack was generated for private distribution only  #
# ----------------------------------------------------------- #
#                         DATAPACK INFO                       #
# ----------------------------------------------------------- #
#     Author: GenMode                                         #
#     Twitter: @DatapackGen                                   #
#     URL: https://github.com/GenMode/Minecraft/wiki          #
#                                                             #
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#


# Init
$execute if data storage data:store PlayerGUI[{UUID:$(UUID)}].Pages[{page:$(page)}] run tag @s add temp.RUN
$execute as @s[tag=temp.RUN] if data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage{store_items:true} run function data_api:run/containers/player_gui/functions/copy_inventory_to_storage {path:"SelectedPage.Items", UUID:"$(UUID)"}
$execute as @s[tag=temp.RUN] if data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage{store_items:true} run function data_api:run/containers/player_gui/functions/page_macro {nbt:"count", function:"data_api:run/containers/player_gui/functions/clear_item"}
$execute as @s[tag=temp.RUN] if data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage run function data_api:run/containers/player_gui/functions/copy_selected_page_to_storage with storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage

# Modify Data (inventory)
$execute as @s[tag=temp.RUN] unless data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage run function data_api:run/containers/player_gui/functions/copy_inventory_to_storage {path:"Inventory", UUID:"$(UUID)"}
$execute as @s[tag=temp.RUN] unless data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage run data remove storage data:store PlayerGUI[{UUID:$(UUID)}].Inventory[{components:{"minecraft:custom_data":{gui:"button"}}}]
$execute as @s[tag=temp.RUN] unless data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage run data remove storage data:store PlayerGUI[{UUID:$(UUID)}].Inventory[{components:{"minecraft:custom_data":{gui:true}}}]
$execute as @s[tag=temp.RUN] unless data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage run function data_api:run/containers/player_gui/functions/page_macro {nbt:"count", function:"data_api:run/containers/player_gui/functions/clear_item"}

# Modify Data (page)
$execute as @s[tag=temp.RUN] run data modify storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage set from storage data:store PlayerGUI[{UUID:$(UUID)}].Pages[{page:$(page)}]
execute as @s[tag=temp.RUN] run function data_api:run/commands/check_inventory/if_data {data:"components.\"minecraft:custom_data\".gui", function:"data_api:run/containers/player_gui/functions/clear_gui"}
$execute as @s[tag=temp.RUN] at @s unless data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage{convert_data:true} run function data_api:run/commands/check_inventory/if_data {data:"components.\"minecraft:custom_data\"{has_temporary_data:true}", function:"data_api:run/containers/player_gui/functions/remove_custom_data"}
$execute as @s[tag=temp.RUN] at @s unless data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage{keep_items:true} run function data_api:run/containers/player_gui/functions/page_macro_if_unless {if_nbt:"count", unless_nbt:"components.\"minecraft:custom_data\".gui", function:"data_api:run/containers/player_gui/functions/return_item_from_page"}
$execute as @s[tag=temp.RUN] if data storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage{store_items:true} run function data_api:run/containers/player_gui/functions/copy_storage_to_inventory {path:"SelectedPage.Items", UUID:"$(UUID)"}

# Scores
$execute as @s[tag=temp.RUN] store result score @s gui.Count run data get storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage.item_count
$execute as @s[tag=temp.RUN] store result score @s gui.Page run data get storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage.page
$execute as @s[tag=temp.RUN] run data modify storage data:store PlayerGUI[{UUID:$(UUID)}].SelectedPage.UUID set from entity @s UUID
execute as @s[tag=temp.RUN] run scoreboard players operation @s gui.PageB = @s gui.Page

# Close
advancement grant @s[tag=temp.RUN] only data_api:inventory_changed/objectives gui_page
tag @s remove temp.RUN
