#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
#  This Datapack was generated for private distribution only  #
# ----------------------------------------------------------- #
#                         DATAPACK INFO                       #
# ----------------------------------------------------------- #
#     Author: GenMode                                         #
#     Twitter: @DatapackGen                                   #
#     URL: https://github.com/GenMode/Minecraft/wiki          #
#                                                             #
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#


# Init
execute on vehicle run tag @s[type=minecraft:chest_minecart] add data_api.temp.TARGET
$execute if data entity @s data.GUI.Pages[{page:$(page)}] run tag @s add temp.RUN
execute as @s[tag=temp.RUN] at @s if data entity @s data.GUI.SelectedPage{store_items:true} run function data_api:run/containers/minecart_gui/functions/copy_items_to_selected_page
execute as @s[tag=temp.RUN] if data entity @s data.GUI.SelectedPage run function data_api:run/containers/custom_gui/functions/copy_selected_page_to_storage with entity @s data.GUI.SelectedPage

# Modify Data
execute as @s[tag=temp.RUN] at @s on vehicle run function data_api:run/containers/minecart_gui/functions/page_macro {function:"data_api:run/containers/minecart_gui/functions/clear_gui", nbt:"components.\"minecraft:custom_data\".gui"}
$execute as @s[tag=temp.RUN] run data modify entity @s data.GUI.SelectedPage set from entity @s data.GUI.Pages[{page:$(page)}]
execute as @s[tag=temp.RUN] at @s unless data entity @s data.GUI.SelectedPage{keep_items:true} on vehicle run function data_api:run/containers/minecart_gui/functions/page_macro_if_unless {function:"data_api:run/commands/return_item_from_entity", if_nbt:"count", unless_nbt:"components.\"minecraft:custom_data\".gui"}
execute as @s[tag=temp.RUN] at @s run data modify entity @e[type=minecraft:chest_minecart, tag=data_api.temp.TARGET, limit=1] CustomName set from entity @s data.GUI.SelectedPage.CustomName
execute as @s[tag=temp.RUN] at @s if data entity @s data.GUI.SelectedPage{store_items:true} run data modify entity @e[type=minecraft:chest_minecart, tag=data_api.temp.TARGET, limit=1] Items set from entity @s data.GUI.SelectedPage.Items

# Scores
execute as @s[tag=temp.RUN] store result score @s gui.Count run data get entity @s data.GUI.SelectedPage.item_count
execute as @s[tag=temp.RUN] store result score @s gui.Page run data get entity @s data.GUI.SelectedPage.page
execute as @s[tag=temp.RUN] run scoreboard players operation @s gui.PageB = @s gui.Page

# Close
execute as @s[tag=temp.RUN] at @s run function data_api:run/containers/minecart_gui/functions/reset_page
tag @s remove temp.RUN
tag @e[type=minecraft:chest_minecart] remove data_api.temp.TARGET
