#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
#  This Datapack was generated for private distribution only  #
# ----------------------------------------------------------- #
#                         DATAPACK INFO                       #
# ----------------------------------------------------------- #
#     Author: GenMode                                         #
#     Twitter: @DatapackGen                                   #
#     URL: https://github.com/GenMode/Minecraft/wiki          #
#                                                             #
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
# Tracking: 11cpt

# Init
execute as @e[type=#data_api:init,tag=!init.data_api] at @s run function data_api:run/entities/loadup

# Blocks
execute as @e[type=minecraft:marker, scores={gui.Page=-1..}] at @s if entity @a[distance=..6] run function data_api:run/containers/custom_gui/check
execute if entity @e[type=minecraft:marker, tag=data.BlockEntity] run function data_api:run/blocks/main
execute if entity @e[type=marker, tag=data_api.glow] run function data_api:run/objectives/set_light/check

# Entities
execute if entity @e[type=#minecraft:display_entities, nbt={item:{components:{"minecraft:custom_data":{custom_entity_data:{}}}}}] run function data_api:run/entities/custom_mob/main
execute if entity @e[type=minecraft:villager, scores={entt.Villager=-1..}] run function data_api:run/entities/villagers/ping

# Items
execute as @e[type=#data_api:wears_armor, predicate=data_api:misc/items/tags/prevent_equip, limit=1] at @s run function data_api:run/items/tags/prevent_equip
execute if entity @e[type=#data_api:wears_hats] run function data_api:run/items/tags/custom_hat_data/ping

# Objectives
execute if entity @e[scores={set.Light=1..15}] run function data_api:run/objectives/set_light/ping
execute if entity @e[type=#minecraft:display_entities, scores={match.Brightness=-1..}] run function data_api:run/objectives/match_brightness/ping
execute if score *dev_mode data_api.Settings matches 1 if predicate data_api:time_check/period/1s run function data_api:run/objectives/settings
